﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

    [DefaultEvent("ValueChanged")]
    public partial class TrackBarWithLabel : UserControl
    {
        public TrackBarWithLabel()
        {
            InitializeComponent();
            this.lblValue.Text = this.ultraTrackBar1.Value.ToString();
        }

        [Browsable(true)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
        [EditorBrowsable(EditorBrowsableState.Always)]
        [Bindable(true)]
        public override string Text
        {
            get
            {
                return this.lblText.Text;
            }
            set
            {
                this.lblText.Text = value;
                base.Text = value;
            }
        }

        public int MinValue
        {
            get { return this.ultraTrackBar1.MinValue; }
            set { this.ultraTrackBar1.MinValue = value; }
        }

        public int MaxValue
        {
            get { return this.ultraTrackBar1.MaxValue; }
            set { this.ultraTrackBar1.MaxValue = value; }
        }

        public int Value
        {
            get { return this.ultraTrackBar1.Value; }
            set { this.ultraTrackBar1.Value = value; }
        }


        public int LargeChange
        {
            get { return this.ultraTrackBar1.LargeChange; }
            set { this.ultraTrackBar1.LargeChange = value; }
        }

        public int SmallChange
        {
            get { return this.ultraTrackBar1.SmallChange; }
            set { this.ultraTrackBar1.SmallChange = value; }
        }

        private void ultraTrackBar1_ValueChanged(object sender, EventArgs e)
        {
            this.lblValue.Text = this.ultraTrackBar1.Value.ToString();

            if (this.ValueChanged != null)
                this.ValueChanged(this, EventArgs.Empty);            
        }

        
        public event EventHandler ValueChanged;            
    }

